﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Configuration;

/*******************************************************
 
 ** 作者: SoFlash - 博客园  http://www.cnblogs.com/longwu
 
 ** 描述: FrmLogin.cs 用于 用户登录窗体的 实现 

 ******************************************************/

namespace 电影记录管理系统
{
    public partial class FrmLogin : Form
    {
        public FrmLogin()
        {
            InitializeComponent();
        }

        //用于连接配置文件App.config
        string connStr = ConfigurationManager.ConnectionStrings["str"].ConnectionString;

         //定义一个全局变量 Uid;
        //用于获取登录成功后的用户名
        public static string Uid;

        //定义一个全局变量 Time
        //用于获取登录成功后的用户的登录时间
        public static DateTime Time;

        //定义一个登录全局变量 用来获取 "登录" 或是"退出"
        public static string Situation;

        //定义一个全局变量UserType 用来获 登录用户的类型
        public static string UserType;

        //定义一个全局变量 数组FRight 来获取登录成功的普通用户功能权限
        public static int[] FRight;

        private void btnLogin_Click(object sender, EventArgs e)
        {
            //使用SqlConnection 来连接数据库
            using (SqlConnection conn = new SqlConnection(connStr))
            {
                // 注释掉之前的select语句 string sql = "select MUserPwd from MovieAccount where MUserName ='" + txtName.Text + "'";
                //---------------------新增代码----------------------//
                //这里新增了 RightFManager,RightFRegistration,RightFPwdChange,RightFLog 几条字段 用于获取普通用户登录后的功能权限值 
                string sql = "select MUserPwd,UserType,RightFManager,RightFRegistration,RightFPwdChange,RightFLog from MovieAccount where MUserName ='" + txtName.Text + "'";
                //---------------------新增代码----------------------//

                //创建 SqlCommand 数据库执行指令
                using (SqlCommand cmd = new SqlCommand(sql, conn))
                {
                    //打开数据库连接
                    conn.Open();
                    //使用 SqlDataReader 来 读取数据库  
                    using (SqlDataReader sdr = cmd.ExecuteReader())
                    {
                        //SqlDataReader 在数据库中为 从第1条数据开始 一条一条往下读 
                        if (sdr.Read())  //如果读取账户成功(文本框中的用户名在数据库中存在)
                        {
                            //则将对应该用户名下的 第一个字段 即使密码(MUserPwd为select的第一个字段) 赋给 字符串pwd,并且依次往后读取 所有的密码
                            //Trim()方法为移除字符串前后的空白
                            string pwd = sdr.GetString(0).Trim();

                            //读取器sdr获取了2列数据 第1列为密码索引为0 第2列即索引为1的是用户类型
                            string uType = sdr.GetString(1);


                            //如果 文本框中输入的密码 ==数据库中的密码
                            if (pwd == txtPwd.Text)
                            {
                                //获取登陆成功后的用户ID
                                Uid = txtName.Text;

                                //添加一段获取登录时间的代码
                                //new一个当前用户的登录时间 用来获取当前时间
                                DateTime currentTime = new DateTime();
                                //获取当前登录时间
                                currentTime = DateTime.Now;
                                //将当前登录的时间赋给全局变量 Time
                                Time = currentTime;

                                //添加获取当前登录情况的代码
                                //获取当前用户登录的情况
                                Situation = "登录";

                                //将登录成功的用户类型 赋给全局变量UserType
                                //用于获取当前登录 用户的类型
                                UserType = uType;

                                /************用户登录成功后 对用户类型进行判断********************/

                                //用户功能权限索引i  对应的数据读取器sdr里的索引是 是 i+2
                                //FRight[0] = sdr.GetInt32(2);   //RightFManager
                                //FRight[1] = sdr.GetInt32(3);   //RightFRegistration
                                //FRight[2] = sdr.GetInt32(4);   //RightFPwdChange
                                //FRight[3] = sdr.GetInt32(5);   //RightFLog

                                //如果用户为普通用户 则检查 其功能权限 管理员不被检查    
                                if (UserType == "NormalUser")
                                {
                                    FRight = new int[4];
                                    for (int i = 0; i < FRight.Length; i++)
                                    {
                                        if (sdr.GetInt32(i + 2) == 0)      //如果数据读取器中读到数据库中的权限值为0
                                        {
                                            FRight[i] = 0;                 //则赋给全局变量0  说明该功能被禁用   
                                        }
                                        else if (sdr.GetInt32(i + 2) == 1) //如果 为1 
                                        {
                                            FRight[i] = 1;                 //赋给全局变量1   该功能可用
                                        }
                                        else
                                        {
                                            FRight[i] = 0;                 //否则默认为0  该功能不可用
                                        }
                                    }
                                }
                                /*****************************************************************/

                                //说明在该账户下 密码正确, 系统登录成功
                                MessageBox.Show("系统登录成功,正在跳转主页面...");
                                FrmMain main = new FrmMain();
                                main.Show();
                                this.Hide();
                            }
                            else
                            {
                                //否则密码错误 再次输入密码
                                MessageBox.Show("密码错误!请再次输入!");
                                //并自动将当前密码 清空
                                txtPwd.Text = "";
                            }
                        }
                        else
                        {
                            //如果读取账户数据失败, 则用户名不存在
                            MessageBox.Show("用户名不存在,请重新出入!");
                            //并自动清空账户名
                            txtName.Text = "";
                        }
                    }
                }
            }
        }
    }
}
