﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Configuration;
using System.Data.SqlClient;
using Microsoft.Office.Interop.Excel;
using System.IO;
using System.Data.OleDb;

/*******************************************************
 
 ** 作者: SoFlash - 博客园  http://www.cnblogs.com/longwu
 
 ** 描述: FrmManager.cs 电影记录管理界面 用于对数据库中 电影记录的增删改查

 ******************************************************/

namespace 电影记录管理系统
{
    public partial class FrmManager : Form
    {
        public FrmManager()
        {
            InitializeComponent();

        }
        //连接字符串 获取配置文件里的连接路径
        static string connStr = ConfigurationManager.ConnectionStrings["str"].ConnectionString;

        //查看并刷新所有数据
        private void btnView_Click(object sender, EventArgs e)
        {
            string sql = "select Id,Movie_Name,Movie_Director,Date_Released from Record";
            SqlConnection conn = new SqlConnection(connStr);
            SqlCommand cmd = new SqlCommand(sql, conn);
            System.Data.DataTable dt = new System.Data.DataTable();
            SqlDataAdapter sda = new SqlDataAdapter(cmd);
            sda.Fill(dt);
            dgvManager.DataSource = dt;
        }

        //添加数据
        private void btnAdd_Click(object sender, EventArgs e)
        {
            //定义一个初始值n=0, 用于判断后期是否成功插入数据
            int n = 0;
            string sql = "insert into Record(Movie_Name,Movie_Director,Date_Released) values (@Movie_Name,@Movie_Director,@Date_Released)";
            //判断插入的数据是否为空,如果为空,则提示重新插入!
            if (txtMovie.Text.Trim() == "" || txtDirector.Text.Trim() == "" || txtDate.Text.Trim() == "")
            {
                MessageBox.Show("插入数据不能为空,请按要求插入数据!");
                return;
            }
            //向数据库插入参数
            SqlParameter[] param ={
                                       new SqlParameter("@Movie_Name",txtMovie.Text),
                                       new SqlParameter("@Movie_Director",txtDirector.Text),
                                       new SqlParameter("@Date_Released",Convert.ToDateTime(txtDate.Text))
 
                                   };
            SqlConnection conn = new SqlConnection(connStr);
            SqlCommand cmd = new SqlCommand(sql, conn);
            conn.Open();
            cmd.Parameters.AddRange(param);
            n = cmd.ExecuteNonQuery();
            if (n == 0)
            {
                MessageBox.Show("添加失败!");
                return;
            }
            else if (n > 0)
            {
                MessageBox.Show("添加成功!");
            }
            conn.Close();
            //调用refresh方法,在添加完成数据后 自动刷新 显示新数据
            Refresh();
        }

        //写一个刷新数据的方法(跟查看数据一样)
        public override void Refresh()
        {
            string sql = "select Id,Movie_Name,Movie_Director,Date_Released from Record";
            SqlConnection conn = new SqlConnection(connStr);
            SqlCommand cmd = new SqlCommand(sql, conn);
            System.Data.DataTable dt = new System.Data.DataTable();
            SqlDataAdapter sda = new SqlDataAdapter(cmd);
            sda.Fill(dt);
            dgvManager.DataSource = dt;
        }

        //删除数据
        private void btnDelete_Click(object sender, EventArgs e)
        {
            //使用sql删除语句
            string sql = "delete from Record where 1=1";
            //如果datagridview的当前行被选中
            if (dgvManager.CurrentRow.Selected)
            {
                //将sql语句 delete from Record where 1=1 + and Id = + 当前选中行的第0个单元格的号码(即Id号)
                sql = sql + "and Id=" + Convert.ToInt32(dgvManager.CurrentRow.Cells[0].Value.ToString());
            }
            int n = 0;
            SqlConnection conn = new SqlConnection(connStr);
            SqlCommand cmd = new SqlCommand(sql, conn);
            conn.Open();
            n = cmd.ExecuteNonQuery();
            if (n == 0)
            {
                MessageBox.Show("不存在的ID!");
                return;

            }
            else if (n > 0)
            {
                MessageBox.Show("删除成功!");
            }
            conn.Close();
            //删除完后 刷新一下当前数据
            Refresh();
        }


        //更新数据操作
        private void btnSave_Click(object sender, EventArgs e)
        {
            //在对数据进行修改之前 对文本框的内容做一下检查, 如果为空 则提示重新输入
            if (txtMovie.Text.Trim() == "" || txtDirector.Text.Trim() == "" || txtDate.Text.Trim() == "")
            {
                MessageBox.Show("文本框的输入不能为空!");
                return;
            }
            //使用SQL update 更新语句
            //获取文本框中输入的内容, 通过Id进行更新(Id为当前鼠标点击行的Id)
            string sqlUpdate = "update Record set Movie_Name ='" + txtMovie.Text + "',Movie_Director ='"
             + txtDirector.Text + "',Date_Released='" + txtDate.Text +
            "'where Id='" + dgvManager.CurrentRow.Cells[0].Value.ToString() + "'";
            SqlConnection conn = new SqlConnection(connStr);
            SqlCommand cmdUpdate = new SqlCommand(sqlUpdate, conn);
            conn.Open();
            int n = cmdUpdate.ExecuteNonQuery();
            if (n == 0)
            {
                //提示更新失败
                MessageBox.Show("更新失败!");
                return;// 并且返回
            }
            else if (n > 0)
            {
                //否则更新成功
                MessageBox.Show("恭喜你!更新成功!");
            }
            //执行完数据更新操作后 需要关闭数据库 节省资源
            conn.Close();
            //更新完以后  调用刷新方法,将更新后的数据 显示在datagridview上面
            Refresh();
        }

        //将鼠标点击的datagridview 上的行内容传递给 文本框
        private void dgvManager_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {
            //获取字段名为Movie_Name的单元格内容
            txtMovie.Text = dgvManager.Rows[e.RowIndex].Cells["Movie_Name"].Value.ToString();
            //同理 获取当前点击行里的 name属性为Movie_Director的单元格 获取并将其传至txtDirector 文本框
            txtDirector.Text = dgvManager.Rows[e.RowIndex].Cells["Movie_Director"].Value.ToString();
            //new一个时间对象 目的是将电影发行时间的小时,分和秒给去掉 保留到最小单位为日
            DateTime datetoDay = new DateTime().Date;
            //将当前行的日期单元格的值 赋给 时间对象datetoDay
            datetoDay = Convert.ToDateTime(dgvManager.Rows[e.RowIndex].Cells["Date_Released"].Value);
            //通过ToShortDateString()方法 将日期后的00:00:00 给剔除掉 并赋给 txtDate文本框
            txtDate.Text = datetoDay.ToShortDateString();
        }

        private void btnBack_Click(object sender, EventArgs e)
        {
            //返回主界面
            FrmMain main = new FrmMain();
            main.Show();
            this.Close();
        }

        //直接退出系统
        private void btnExit_Click(object sender, EventArgs e)
        {
            //调用FrmLog窗体 获取当前时间退出的方法
            FrmLog log = new FrmLog();
            log.GetExitTime();

            //方法调用
            //将当前用户的登录信息添加到DataGridView里面
            log.AddLog();

            //直接退出系统
            System.Windows.Forms.Application.Exit();
        }


        //当系统加载的时候自动显示DataGridView的数据
        private void FrmManager_Load(object sender, EventArgs e)
        {
            //调用刷新数据的方法
            Refresh();
            cmbforTypeSelecting.Text = "全局搜索";
            cmbforTypeSelecting.Items.Add("全局搜索");
            cmbforTypeSelecting.Items.Add("编号");
            cmbforTypeSelecting.Items.Add("电影名称");
            cmbforTypeSelecting.Items.Add("导演");
            cmbforTypeSelecting.Items.Add("发行时间");

            //----------------------新增代码-------------------//
            //添加对用户 类型的判断 用来设置功能按钮的使用权限
            if (FrmLogin.UserType == "NormalUser")
            {
                btnDelete.Enabled = false;
                btnAdd.Enabled = false;
                btnSave.Enabled = false;
            }
            //----------------------新增代码-------------------//
        }

        string seletedValue;

        private void txtDataforQuery_TextChanged(object sender, EventArgs e)
        {
            string sql = "";
            if (txtDataforQuery.Text.Trim() == "")
            {
                //执行查询语句
                sql = "select * from Record";
            }
            else if (seletedValue == "全局搜索" || cmbforTypeSelecting.Text == "全局搜索")
            {
                //全字段搜索
                sql = "select * from Record where(Id like'%" + txtDataforQuery.Text.Trim() + "%')or(Movie_Name like'%" + txtDataforQuery.Text.Trim() + "%')or(Movie_Director like'%" + txtDataforQuery.Text.Trim() + "%')or(Date_Released like'%" + txtDataforQuery.Text.Trim() + "%')";
            }
            else if (seletedValue == "Id" || seletedValue == "Movie_Name" || seletedValue == "Movie_Director" || seletedValue == "Date_Released")
            {
                //通过相应的字段进行搜索
                sql = "select * from Record where " + seletedValue + " like '%" + txtDataforQuery.Text.Trim() + "%'";
            }

            SqlConnection conn = new SqlConnection(connStr);
            SqlCommand cmd = new SqlCommand(sql, conn);
            System.Data.DataTable dt = new System.Data.DataTable();
            SqlDataAdapter sda = new SqlDataAdapter(cmd);
            sda.Fill(dt);
            dgvManager.DataSource = dt;
        }

        private void cmbforTypeSelecting_SelectedIndexChanged(object sender, EventArgs e)
        {
            string strSelected = cmbforTypeSelecting.Text;
            switch (strSelected)
            {
                case "全局搜索":
                    seletedValue = "全局搜索";
                    break;
                case "编号":
                    seletedValue = "Id";
                    break;
                case "电影名称":
                    seletedValue = "Movie_Name";
                    break;
                case "导演":
                    seletedValue = "Movie_Director";
                    break;
                case "发行时间":
                    seletedValue = "Date_Released";
                    break;
                default:
                    seletedValue = "全局搜索";
                    break;
            }
        }

        //导出为Excel文件 
        public void ExportExcel(DataGridView dgv)
        {
            try
            {
                //首先判断 DataGridView里面是否有内容 没内容则弹出提示并不再执行
                if (dgv.Rows.Count == 0)
                {
                    MessageBox.Show("没数据可导出,请插入数据!");
                    return;
                }
                //首先我们需要创建一个Excel对象
                Microsoft.Office.Interop.Excel.Application excel = new Microsoft.Office.Interop.Excel.Application();
                excel.Application.Workbooks.Add(true); //给Excel 对象 添加一个Excel Workbooks

                //生成Excel的 列头名称  
                for (int i = 0; i < dgv.ColumnCount; i++)
                {
                    excel.Cells[1, i + 1] = dgvManager.Columns[i].HeaderText.ToString();
                }

                //遍历所有行
                for (int i = 0; i < dgv.RowCount - 1; i++)
                {
                    //遍历每一行的中的所有列 从而实现所有单元格的遍历
                    for (int j = 0; j < dgv.ColumnCount; j++)
                    {
                        excel.Cells[i + 2, j + 1] = dgv[j, i].Value.ToString();
                    }
                }
                excel.DisplayAlerts = false;
                excel.AlertBeforeOverwriting = false;
                excel.Save("excel.xls");
                MessageBox.Show("导出Excel成功!");
                excel.Quit();//关闭Excel进程    
                excel = null;
            }
            catch (Exception e)
            {
                MessageBox.Show(e.Message);
            }
        }

        private void btnExportExcel_Click(object sender, EventArgs e)
        {
            //调用 ExportExcel方法 导出DataGridView 的内容到Excel
            ExportExcel(dgvManager);
        }

        public void ImportExcel(String filePath, DataGridView dgv)
        {
            /******************************* ①打开Excel文件 并读取里面的数据 ***************************************/

            //根据路径打开一个Excel文件并将数据填充到DataSet中 以便 Sql Server 执行数据插入语句时 调用

            //03版本 Excel 连接字符串       如果用03版本 连接字符串 打开07版本的Excel 会提示报错 "外部表不是预期的格式"
            //string connExcel = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source = " + filePath + ";Extended Properties ='Excel 8.0;'";

            //07版本 Excel 连接字符串  这里使用07版本的 兼容03版本
            string connExcel = "Provider=Microsoft.ACE.OLEDB.12.0;Data Source = " + filePath + ";Extended Properties ='Excel 8.0;'";
            OleDbConnection OleDbConn;

            try
            {
                //创建OleDbConn连接 
                OleDbConn = new OleDbConnection(connExcel);
                OleDbConn.Open();
                //创建 Excel 数据表
                //Microsoft.Office.Interop.Excel.DataTable dtExcel = OleDbConn.GetOleDbSchemaTable(OleDbSchemaGuid.Tables, null);
				System.Data.DataTable dtExcel = OleDbConn.GetOleDbSchemaTable(OleDbSchemaGuid.Tables, null);
                //获取Excel表
                string tableName = dtExcel.Rows[0][2].ToString().Trim();
                tableName = "[" + tableName.Replace("'", "") + "]";
                string queryExcel = "select 电影名称,导演,发行日期 from " + tableName;
                //创建数据集ds  用于后期装载 OleDbDataAdapter 中的获取的结果
                DataSet ds = new DataSet();
                OleDbDataAdapter oleAdapter = new OleDbDataAdapter(queryExcel, connExcel);
                oleAdapter.Fill(ds, "Record");
                OleDbConn.Close();

                /*************************** ①Excel文件数据读取完成  ***********************************************/


                /**************************  ②获取Excel数据后,将数据导入到Sql Server ********************************/

                string sqlInsert = null; //初始化sql 
                int n = 0;    //定义一个整数 用于获取  ExecuteNonQuery()成功执行的行数 
                //遍历 ds数据集中的 Record表里的所有行
                foreach (DataRow dr in ds.Tables["Record"].Rows)
                {
                    //创建插入语句
                    sqlInsert = "insert into Record(Movie_Name,Movie_Director,Date_Released) values('";

                    //每行有3个字段  电影名称,导演 和 发行日期
                    sqlInsert += dr.ItemArray[0] + "','";
                    sqlInsert += dr.ItemArray[1] + "','";
                    sqlInsert += dr.ItemArray[2] + "')";
                    SqlConnection conn = new SqlConnection(connStr);
                    SqlCommand cmd = new SqlCommand(sqlInsert, conn);
                    conn.Open();
                    n += cmd.ExecuteNonQuery();  //每次成功 +1
                    conn.Close();
                }
                //如果 n> 0  表示数据插入成功
                if (n > 0)
                {
                    MessageBox.Show("添加成功! 共插入" + n.ToString() + "条数据");
                }
                else //否则失败
                {
                    MessageBox.Show("添加失败!");
                    return;
                }
                /**************************  ②数据导入到Sql Server完成 **********************************************/

                //调用refresh方法,在添加完成数据后 自动刷新DataGridView表 显示新数据
                Refresh();

            }
            catch (Exception e)
            {
                //在整个过程中 如果出错的话 显示错误信息
                MessageBox.Show(e.Message, "错误消息");
            }

        }

        private void btnImportExcel_Click(object sender, EventArgs e)
        {
            //选择需要导入的Excel文件
            OpenFileDialog ofDialog = new OpenFileDialog();
            ofDialog.Title = "请选择需要导入的Excel文件";
            ofDialog.Filter = "Excel Files(07版本 *.xlsx)|*.xlsx|(03版本 *.xls)|*.xls|所有文件(*.*)|*.*";

            string fullPath = string.Empty;
            if (ofDialog.ShowDialog() == DialogResult.OK)
            {
                fullPath = ofDialog.FileName;
            }
            if (fullPath == "")
            {
                MessageBox.Show("未选择Excel文件");
                return;
            }
            //调用导入 Excel文件方法 
            ImportExcel(fullPath, dgvManager);
        }
    }
}
