﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Configuration;
using System.Data.SqlClient;

/*******************************************************
 
 ** 作者: SoFlash - 博客园  http://www.cnblogs.com/longwu
 
 ** 描述: FrmRegistration.cs  用户注册窗体

 ******************************************************/

namespace 电影记录管理系统
{
    public partial class FrmRegistration : Form
    {
        public FrmRegistration()
        {
            InitializeComponent();
            {
            }
        }
        //连接字符串, 获取配置文件App.config里的字符串"str"
        static string connStr = ConfigurationManager.ConnectionStrings["str"].ConnectionString;

        private void btnOK_Click(object sender, EventArgs e)
        {

            //否则判断 当前用户名在数据库中是否存在
            //使用sql select语句 按 用户文本框中的文本内容 来选取数据库中的用户名
            string sql = "select MUserName from MovieAccount where MUserName='" + txtUid.Text + "'";
            //新建SQL 数据库连接
            SqlConnection conn = new SqlConnection(connStr);
            //使用SQL cmd指令来装载 sql查询语句和数据库连接
            SqlCommand cmd = new SqlCommand(sql, conn);
            //执行操作前  需要打开数据库连接
            conn.Open();
            //使用SqlDataReader 对cmd 执行读取指令的数据 进行逐行读取
            SqlDataReader sdr = cmd.ExecuteReader();
            //如果读到数据了,说明 数据库中已存在 文本框中输入的用户名
            if (sdr.Read())
            {
                //如果读到相同的用户名 则提示 用户名已存在
                lblUidMsg.Text = "用户名已存在,请重新输入!";
                return;
            }

            //如果用户名不存在 则判断下用户名密码是否为空
            else if (txtUid.Text.Trim() == "")
            {

                //如果用户名 不为空, 将提示语句赋给label框 并在窗体上
                lblUidMsg.Text = "用户名不能为空!";

            }

                //判断密码是否为空
            else if (txtPwd.Text.Trim() == "")
            {
                //同理
                lblPwdMsg.Text = "密码不能为空!";
                //同时清除 用户名 提示框的内容
                lblUidMsg.Text = "";

            }
            //判断再次输入密码是否为空
            else if (txtPwdConfirm.Text.Trim() == "")
            {
                //同理
                lblPwdConfirmMsg.Text = "验证密码不能为空!";
                //同时清除 用户名 提示框 和 第一次密码输入提示框的内容
                lblUidMsg.Text = "";
                lblPwdMsg.Text = "";

            }
            //判断2次密码输入是否相同
            else if (txtPwd.Text.Trim() != txtPwdConfirm.Text.Trim())
            {
                //同理
                lblPwdMsg.Text = "2次密码必须一样!";
                lblPwdConfirmMsg.Text = "请重新输入!";
                return;
            }
            else //如果通过上述检测,则进行账户 密码插入数据库操作
            {
                //清空上面所有label框的提示
                lblUidMsg.Text = "";
                lblPwdMsg.Text = "";
                lblPwdConfirmMsg.Text = "";

                //如果 用户名是否存在于 数据库判断完了 则关闭数据库连接(节省资源)
                conn.Close();

                //----------------------新增代码-------------------------//
                //new一个 uType 来获取 radiobutton 点击事件下 触发的用户类型赋值
                string uType = "";

                int rightFManager = 0;
                int rightFRegistration = 0;
                int rightFPwdChange = 0;
                int rightFLog = 0;

                if (rdoAdministrator.Checked)  //当管理员的radiobutton被点击后
                {
                    uType = "Administrator";   //传给 uType 一个管理员
                    rightFManager = 1;
                    rightFRegistration = 1;
                    rightFPwdChange = 1;
                    rightFLog = 1;
                }
                else if (rdoNormalUser.Checked)  //同理
                {
                    uType = "NormalUser";
                }
                else                             //若不点击 则默认为普通用户注册 
                    uType = "NormalUser";
                //sql 插入语句  我们新增了 一列 UserType
                string sqlInsert = "insert into MovieAccount(MUserName,MUserPwd,UserType,RightFManager,RightFRegistration,RightFPwdChange,RightFLog) values (@MUserName,@MUserPwd,@UserType,@RightFManager,@RightFRegistration,@RightFPwdChange,@RightFLog)";
                //使用1个SQL参数数组 来装载 需要插入的数据
                SqlParameter[] param = {
                                       new SqlParameter("@MUserName",txtUid.Text),
                                       new SqlParameter("@MUserPwd",txtPwd.Text),  
                                       new SqlParameter("@UserType",uType),   
                                        new SqlParameter("@RightFManager",rightFManager),
                                      new SqlParameter("@RightFRegistration",rightFRegistration),
                                      new SqlParameter("@RightFPwdChange",rightFPwdChange),
                                      new SqlParameter("@RightFLog",rightFLog)
                                       };
                //----------------------新增代码-------------------------//
                //使用 SQL数据库连接
                SqlConnection connInsert = new SqlConnection(connStr);
                //使用SQL command 指令来装载 SQL查询语句和SQL数据库连接
                SqlCommand cmdInsert = new SqlCommand(sqlInsert, connInsert);

                connInsert.Open();
                //使用cmd指令 添加所有参数
                cmdInsert.Parameters.AddRange(param);
                //定义一个整型变量 用于接受 cmd的 执行查询指令(cmd的xecuteNonQuery()方法返回的为一个整型值)
                int n = cmdInsert.ExecuteNonQuery();
                //判断该值是否为空, 如果为空, 说明插入数据失败
                if (n == 0)
                {
                    MessageBox.Show("注册失败!,请重新输入");
                    //插入失败就不再继续运行,返回
                    return;
                }
                else
                {
                    //否则 数据插入成功
                    MessageBox.Show("注册成功!");
                }
                //关闭数据库连接
                connInsert.Close();
            }

        }

        //返回主窗体
        private void btnBack_Click(object sender, EventArgs e)
        {
            //new一个主窗体对象
            FrmMain main = new FrmMain();
            //跳转到主窗体
            main.Show();
            //隐藏当前窗体
            this.Hide();
        }

        private void FrmRegistration_Load(object sender, EventArgs e)
        {
            //在窗体加载的时候 判断注册用户的类型 
            if (FrmLogin.UserType == "NormalUser")  //如果为普通用户
            {
                rdoAdministrator.Enabled = false;
            }
            else if (FrmLogin.UserType != "NormalUser" && FrmLogin.UserType != "Administrator")
            {
                MessageBox.Show("未知用户登录!");
                return;
            }
        }
    }
}