﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Configuration;
using System.Data.SqlClient;

/*******************************************************
 
 ** 作者: SoFlash - 博客园  http://www.cnblogs.com/longwu
 
 ** 描述: FrmUserManager.cs  用户管理窗体 用于管理员对 普通用户密码修改

 ******************************************************/

namespace 电影记录管理系统
{
    public partial class FrmUserManager : Form
    {

        //定义私有变量-功能权限值 用于获取 radiobutton 被check后的返回值
        private int rightFManager = 0;
        private int rightFRegistration = 0;
        private int rightFPwdChange = 0;
        private int rightFLog = 0;

        //strType 用于获取 当前DataGridView 被点中行的用户类型
        private string strUType = "";

        public FrmUserManager()
        {
            InitializeComponent();
        }

        private void CheckAllUsers()
        {
            //查看当前所有用户
            string sql = "select * from MovieAccount";
            dgvUserManger.DataSource = SqlHelper.ExecuteDataTable(sql);
        }

        private void dgvUserManger_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {
            //点中DataGridView后,将当前行内容传递给文本框 便于在文本框中修改
            txtUserName.Text = dgvUserManger.Rows[e.RowIndex].Cells["MUserName"].Value.ToString();
            txtPwd.Text = dgvUserManger.Rows[e.RowIndex].Cells["MUserPwd"].Value.ToString();
            cboUserType.Text = dgvUserManger.Rows[e.RowIndex].Cells["UserType"].Value.ToString();

            //获取用户类型
            strUType = cboUserType.Text.Trim();

            /************************************************************************************/
            //每次点击 DataGridView新的行之前 都要把前一次点击行的 CheckBox 状态调整为系统默认状态 全未选中 并且都可选
            //比如 如果之前 点了NormalUser 再点Administer 会保留之前NormalUser的选择项 这里我们需要清空
            chkManager.Checked = false;
            chkRegistration.Checked = false;
            chkManager.Checked = false;
            chkLog.Checked = false;

            txtUserName.Enabled = true;
            txtPwd.Enabled = true;
            cboUserType.Enabled = true;
            chkManager.Enabled = true;
            chkPwdChange.Enabled = true;
            chkRegistration.Enabled = true;
            chkLog.Enabled = true;

            /************************************************************************************/
            if (strUType == "NormalUser")
            {
                //如果先前点击了 DataGridView里的 管理员行内容 checkbox 会保留之前的点击状态 我们需要先前的点击状态清除
                chkManager.Checked = true;
                chkRegistration.Checked = true;
                chkManager.Checked = true;
                chkLog.Checked = true;

                //获取当前DataGridView被点中行内容中的用户权限值
                rightFManager = Convert.ToInt32(dgvUserManger.Rows[e.RowIndex].Cells["RightFManager"].Value);
                rightFRegistration = Convert.ToInt32(dgvUserManger.Rows[e.RowIndex].Cells["RightFRegistration"].Value);
                rightFPwdChange = Convert.ToInt32(dgvUserManger.Rows[e.RowIndex].Cells["RightFPwdChange"].Value);
                rightFLog = Convert.ToInt32(dgvUserManger.Rows[e.RowIndex].Cells["RightFLog"].Value);

                //同时判断获取的权限值  并相应的选中Checkbox
                if (rightFManager == 1)
                    chkManager.Checked = true;
                else
                    chkManager.Checked = false;
                if (rightFRegistration == 1)
                    chkRegistration.Checked = true;
                else
                    chkRegistration.Checked = false;
                if (rightFPwdChange == 1)
                    chkPwdChange.Checked = true;
                else
                    chkPwdChange.Checked = false;
                if (rightFLog == 1)
                    chkLog.Checked = true;
                else
                    chkLog.Checked = false;

            }
            //当用户类型为管理员的时候,将所有的CheckBox禁用, 管理员功能权限不允许设置
            else if (strUType == "Administrator")
            {
                chkManager.Enabled = false;
                chkPwdChange.Enabled = false;
                chkRegistration.Enabled = false;
                chkLog.Enabled = false;

                txtUserName.Enabled = false;
                txtPwd.Enabled = false;
                cboUserType.Enabled = false;
            }

        }
        //查询用户信息
        private void txtUserQuery_TextChanged(object sender, EventArgs e)
        {

            string sql = "";

            if (txtUserQuery.Text.Trim() == "")
            {
                //执行查询语句
                sql = "select * from MovieAccount";
            }
            else
            {
                //全局搜索 (通过用户ID  用户名和 用户类型进行模糊查找)
                sql = "select * from MovieAccount where(MId like'%" + txtUserQuery.Text.Trim() + "%')or(MUserName like'%" + txtUserQuery.Text.Trim() + "%')or(UserType like'%" + txtUserQuery.Text.Trim() + "%')";
            }
            //调用SqlHelper类里的查方法
            dgvUserManger.DataSource = SqlHelper.ExecuteDataTable(sql);

        }
        //调用查看所有用户的方法来刷新当前 DataGridView的内容
        private void btnUserCheck_Click(object sender, EventArgs e)
        {
            //点击 "查看所有" 按钮  调用 CheckAllUsers() 方法 刷新 并查当前看所有用户
            CheckAllUsers();
        }

        //添加用户
        private void btnUserAdd_Click(object sender, EventArgs e)
        {

            //使用SQL插入数据语句
            string sql = "insert into MovieAccount(MUserName,MUserPwd,UserType,RightFManager,RightFRegistration,RightFPwdChange,RightFLog) values (@MUserName,@MUserPwd,@UserType,@RightFManager,@RightFRegistration,@RightFPwdChange,@RightFLog)";

            //判断插入的数据是否为空,如果为空,则提示重新插入!
            if (txtUserName.Text.Trim() == "" || txtPwd.Text.Trim() == "" || cboUserType.Text == "")
            {
                MessageBox.Show("插入数据不能为空,请按要求插入数据!");
                return;
            }
            if (cboUserType.Text == "Administrator")
            {
                MessageBox.Show("暂不开放注册管理员功能!");
                return;
            }

            //判断 哪些CheckBox 被选中
            AdjustChecked();

            //向数据库插入参数
            SqlParameter[] param ={
                                      new SqlParameter("@MUserName",txtUserName.Text.Trim()),
                                      new SqlParameter("@MUserPwd",txtPwd.Text.Trim()),
                                      new SqlParameter("@UserType",cboUserType.Text.Trim()),
                                      new SqlParameter("@RightFManager",rightFManager),
                                      new SqlParameter("@RightFRegistration",rightFRegistration),
                                      new SqlParameter("@RightFPwdChange",rightFPwdChange),
                                      new SqlParameter("@RightFLog",rightFLog)

                                  };
            //调用 SqlHelper 增 方法
            int n = SqlHelper.ExcuteNonQuery(sql, param);

            if (n > 0)
            {
                MessageBox.Show("数据插入成功!");
            }
            else
            {
                MessageBox.Show("插入失败!");
                return;
            }

            //调用CheckAllUsers() 方法 用于刷新 在添加完成数据后 自动刷新数据
            CheckAllUsers();
        }

        //保存修改的信息
        private void btnUserChange_Click(object sender, EventArgs e)
        {
            //在对数据进行修改之前 对文本框的内容做一下检查 是否用户已经输入内容, 如果为空 则提示重新输入
            if (txtUserName.Text.Trim() == "" || txtPwd.Text.Trim() == "" || cboUserType.Text.Trim() == "")
            {
                MessageBox.Show("文本框的输入不能为空!");
                return;
            }
            if (cboUserType.Text == "Administrator")
            {
                MessageBox.Show("暂不开放注册管理员功能!");
                return;
            }

            //判断 哪些CheckBox 被选中
            AdjustChecked();

            //使用SQL update 更新语句
            //获取文本框 和ComboBox 输入的内容, 通过用户的ID(MId) 进行更新(ID为当前鼠标点击行的MId)
            string sqlUpdate = "update MovieAccount set MUserName = @MUserName, MUserPwd = @MUserPwd,UserType=@UserType,RightFManager=@RightFManager,RightFRegistration=@RightFRegistration,RightFPwdChange=@RightFPwdChange,RightFLog=@RightFLog where MId=@MId";

            SqlParameter[] param ={
                                      new SqlParameter("@MUserName",txtUserName.Text.Trim()),
                                      new SqlParameter("@MUserPwd",txtPwd.Text.Trim()),
                                      new SqlParameter("@UserType",cboUserType.Text.Trim()),
                                      new SqlParameter("@RightFManager",rightFManager),
                                      new SqlParameter("@RightFRegistration",rightFRegistration),
                                      new SqlParameter("@RightFPwdChange",rightFPwdChange),
                                      new SqlParameter("@RightFLog",rightFLog),
                                      new SqlParameter("@MId",dgvUserManger.CurrentRow.Cells[0].Value),
                                  };

            //调用 SqlHelper 更新方法
            int n = SqlHelper.ExcuteNonQuery(sqlUpdate, param);

            //判定 如果n=0,则说明没有获取到数据,ExecuteNonQuery执行不成功
            if (n == 0)
            {
                //提示更新失败
                MessageBox.Show("更新失败!");
                return;// 并且返回
            }
            else
            {
                //否则更新成功
                MessageBox.Show("恭喜你!更新成功!");
            }

            //保存完以后  调用刷新方法,将更新后的数据 显示在datagridview上面
            CheckAllUsers();
        }

        //删除DataGridView里 选中的用户
        private void btnUserDelete_Click(object sender, EventArgs e)
        {
            //使用sql删除语句
            string sqlDelete = null;
            //如果datagridview的当前行被选中
            if (dgvUserManger.CurrentRow.Selected)
            {
                //获取当前点中行的MID 并且 将当前行的MID号 赋给SQL 语句 
                sqlDelete = "delete from MovieAccount where MId=@MId";
            }

            SqlParameter[] param = {
                                    new SqlParameter("@MId",Convert.ToInt32(dgvUserManger.CurrentRow.Cells[0].Value))      
                                   };
            //调用 SqlHelper 删除的方法
            int n = SqlHelper.ExcuteNonQuery(sqlDelete, param);

            //如果n>0  说明删除数据成功
            if (n > 0)
            {
                MessageBox.Show("删除成功!");
            }
            else //否则失败
            {
                MessageBox.Show("不存在的ID!");
            }
            //删除完后 刷新一下当前数据
            CheckAllUsers();
        }
        //导入当前用户管理窗体的时候 自动查看所有用户信息 以及给Combobox赋予2个选项 管理员和 普通用户
        private void FrmUserManager_Load(object sender, EventArgs e)
        {
            CheckAllUsers();
            cboUserType.Items.Add("Administrator");
            cboUserType.Items.Add("NormalUser");
        }

        //判断CheckBox是否被点重或是取消, 用于更新和修改用户权限
        private void AdjustChecked()
        {
            //当相应的功能权限 checkbox 被点中 或者取消  将分别赋值 并传给相应的私有变量 用于数据库添加,更新等操作
            if (chkManager.Checked == true)
                rightFManager = 1;
            else
                rightFManager = 0;
            if (chkRegistration.Checked == true)
                rightFRegistration = 1;
            else
                rightFRegistration = 0;
            if (chkPwdChange.Checked == true)
                rightFPwdChange = 1;
            else
                rightFPwdChange = 0;
            if (chkLog.Checked == true)
                rightFLog = 1;
            else
                rightFLog = 0;
        }

        //返回主窗体
        private void btnBack_Click(object sender, EventArgs e)
        {
            FrmMain main = new FrmMain();
            main.Show();
            this.Hide();
        }

        //直接退出系统
        private void btnExit_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }
    }
}
